LeetCode每日一题(1416. Restore The Array)

如果 dp[i][prev]是我们遍历到 s[i]且当前累积的数字是 prev 的情况, 那 dp[i][prev] = dp[i+1]prev _ 10 + s[i]] + dp[i+1]s[i]], 如果 prev _ 10 + s[i] > k 那说明我们只能把 s[i]作为新数字的开头, 所以 dp[i][prev] = dp[i+1]s[i]]遍历 s, 对于每个 s[i], 我们要么让它作为新数字的开头, 要么让它作为前面累积数字的结尾。
摘要由CSDN通过智能技术生成

A program was supposed to print an array of integers. The program forgot to print whitespaces and the array is printed as a string of digits s and all we know is that all integers in the array were in the range [1, k] and there are no leading zeros in the array.

Given the string s and the integer k, return the number of the possible arrays that can be printed as s using the mentioned program. Since the answer may be very large, return it modulo 109 + 7.

Example 1:

Input: s = “1000”, k = 10000
Output: 1

Explanation: The only possible array is [1000]

Example 2:

Input: s = “1000”, k = 10
Output: 0

Explanation: There cannot be an array that was printed this way and has all integer >= 1 and <= 10.

Example 3:

Input: s = “1317”, k = 2000
Output: 8

Explanation: Possible arrays are [1317],[131,7],[13,17],[1,317],[13,1,7],[1,31,7],[1,3,17],[1,3,1,7]

Constraints:

  • 1 <= s.length <= 10^5
  • s consists of only digits and does not contain leading zeros.
  • 1 <= k <= 10^9

遍历 s, 对于每个 s[i], 我们要么让它作为新数字的开头, 要么让它作为前面累积数字的结尾。
如果 dp[i][prev]是我们遍历到 s[i]且当前累积的数字是 prev 的情况, 那 dp[i][prev] = dp[i+1]prev _ 10 + s[i]] + dp[i+1]s[i]], 如果 prev _ 10 + s[i] > k 那说明我们只能把 s[i]作为新数字的开头, 所以 dp[i][prev] = dp[i+1]s[i]]



use std::collections::HashMap;

const M: i64 = 1000000007;
impl Solution {
   
    fn dp(nums: &Vec<i64>, k: i64, i: 
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值